//---------------------------------------------------------------------------
#ifndef PGPsdk6H
#define PGPsdk6H

#include "PGPsdk.h"
//---------------------------------------------------------------------------

class PACKAGE TPGPsdk6 : public TPGPsdk
{
public:
   __fastcall virtual TPGPsdk6();
   __fastcall virtual TPGPsdk6(TForm *Owner, const AnsiString &Pubring, const AnsiString &Secring,
      const AnsiString &Remring);
   __fastcall virtual ~TPGPsdk6();
   // cypher
   bool __fastcall VerifyClearSigned(TStrings *SignedText);
   bool __fastcall DecryptMessage(TStrings *Message, char *Passphrase, TStrings *DecKeyIds, bool recurse);
   //bool __fastcall SignMessage(TStrings *Message, char *keyid, char *Passphrase);
   //bool __fastcall EncryptMessage(TStrings *Message, TStrings *KeyIds);
   //bool __fastcall EncryptSignMessage(TStrings *Message, TStrings *EncKeyIds, char *SignKeyid, char *Passphrase);
   // new cipher
   bool __fastcall EncryptToUserID(const AnsiString &Pubring, const AnsiString &UserID, TStrings *Text);
   bool __fastcall EncryptToUserIDs(const AnsiString &Pubring, TStrings *UserIDs, TStrings *theText);
   bool __fastcall EncryptTo(const AnsiString &Pubring, const AnsiString &KeyID, TStrings *Text);
   bool __fastcall EncryptTo(const AnsiString &Pubring, TStrings *KeyIDs, TStrings *Text);
   bool __fastcall EncryptTo(const AnsiString &Passphrase, TStrings *Text);
   // keyring key info functions
   bool __fastcall GetKeysLV(const AnsiString &pubring, const AnsiString &secring, TStrings *Keys);
   bool __fastcall GetKeyLV(const AnsiString &pubring, const AnsiString &secring,
      const AnsiString &keyid, AnsiString &keydesc);
   bool __fastcall GetKeys(const AnsiString &pubring, const AnsiString &secring, TStrings *Keys);
   bool __fastcall GetKeys(const AnsiString &pubring, TStrings *Keys);
   AnsiString __fastcall GetKeyID(const AnsiString &pubring, const AnsiString &UserID);
   bool __fastcall ExportKeys(const AnsiString pubring, const AnsiString secring, TStrings *KeyIDS,
      bool IncludePrivates, TStrings *Exports);
   bool __fastcall ExportKey(const AnsiString pubring, const AnsiString secring, AnsiString KeyID,
      bool IncludePrivate, TStrings *Export);
   // support functions
   bool __fastcall UpdateQSKeyrings(TControl *ForHourGlass);
   bool __fastcall ExportDefaultKeysFast(TStrings *exports);
   bool __fastcall ExportDefaultKeys(TStrings *exports);
   // entropy
   bool __fastcall RandomMouseMoved();
   bool __fastcall GetRandomBytes(void *dataBuf, int size);
   // utility
   AnsiString __fastcall GetLastErrorStr();
   bool __fastcall LoadDefaultPrefs();
   int  __fastcall IdNo();
};

//---------------------------------------------------------------------------

/*
* SDK API version
* example: 1.0.0 = 0x01000000
*   0x01000000   (16777216)   SDK 1.0.0   PGP550
*   0x02000000   (33554432)   SDK 1.1.0
*   0x02000010   (33554448)   SDK 1.1.1   PGP553
*   0x03000000   (50331648)   SDK 1.5.0   PGP600
*   0x03000010   (50331664)   SDK 1.5.1
*   0x03000020   (50331680)   SDK 1.5.2   PGP602
*   0x03001000   (50335744)   SDK 1.6.0
*   0x03002000   (50339840)   SDK 1.7.0   PGP650
*   0x03002010   (50339856)   SDK 1.7.1   PGP651,2,3 // changed pref selectors
*   0x--------   (50339856)   SDK 1.7.8   PGP658
*   0x03000000   (50331648)   SDK 3.0.0
*/

#define PGP600 50331648
#define SDK150 50331648
//---------------------------------------------------------------------------
#endif
